/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180105 (64-bit version)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt2.dat, Mon Mar 18 13:49:24 2024
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000111A (4378)
 *     Revision         0x02
 *     Checksum         0x3F
 *     OEM ID           "AMD"
 *     OEM Table ID     "CPMRAS"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20210331 (539034417)
 */
DefinitionBlock ("", "SSDT", 2, "AMD", "CPMRAS", 0x00000001)
{
    External (_SB_.SMIC, FieldUnitObj)
    External (_SB_.SMIS, FieldUnitObj)

    OperationRegion (RASD, SystemMemory, 0x6EDAD000, 0x0506)
    Field (RASD, ByteAcc, NoLock, Preserve)
    {
        PSIG,   32, 
        PWOC,   32, 
        POSS,   32, 
        POSC,   32, 
        COSS,   32, 
        COSC,   32, 
        HPCK,   32, 
        DPCB,   6400, 
        DPCT,   1792, 
        DPCE,   1600, 
        ISMI,   16, 
        OADR,   64, 
        TADR,   64, 
        EADR,   64, 
        IADR,   64
    }

    Scope (\_SB)
    {
        Method (RD32, 2, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, DWordAcc, Lock, Preserve)
            {
                DATA,   32
            }

            Return (DATA) /* \_SB_.RD32.DATA */
        }

        Method (WR32, 3, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, DWordAcc, Lock, Preserve)
            {
                DATA,   32
            }

            DATA = Arg2
        }

        Method (RD16, 2, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, WordAcc, Lock, Preserve)
            {
                DATA,   16
            }

            Return (DATA) /* \_SB_.RD16.DATA */
        }

        Method (WR16, 3, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, WordAcc, Lock, Preserve)
            {
                DATA,   16
            }

            DATA = Arg2
        }

        Method (RD08, 2, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, ByteAcc, Lock, Preserve)
            {
                DATA,   8
            }

            Return (DATA) /* \_SB_.RD08.DATA */
        }

        Method (WR08, 3, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (PCIM, SystemMemory, (Local0 + Arg1), 0x10)
            Field (PCIM, ByteAcc, Lock, Preserve)
            {
                DATA,   8
            }

            DATA = Arg2
        }

        Method (FCAP, 3, Serialized)
        {
            Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate ("FCAP(Find Pcie Cap) - Arg0(BDF) ", ToHexString (Arg0)), 
                ", Arg1(Standard/Extended?) "), ToHexString (Arg1)), ", Arg2(CapId) "), ToHexString (Arg2))
            Name (CAPP, 0x00)
            If (Arg1)
            {
                CAPP = 0x0100
            }
            Else
            {
                If (((RD08 (Arg0, 0x06) & 0x10) == Zero))
                {
                    Return (Zero)
                }

                Local0 = RD32 (Arg0, 0x34)
                CAPP = (Local0 & 0xFF)
            }

            While (CAPP)
            {
                Local1 = RD32 (Arg0, CAPP)
                If ((Local1 == 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                If ((Arg2 == (Local1 & 0xFF)))
                {
                    Debug = CAPP /* \_SB_.FCAP.CAPP */
                    Return (CAPP) /* \_SB_.FCAP.CAPP */
                }

                If (Arg1)
                {
                    CAPP = (Local1 >> 0x14)
                    If ((CAPP < 0x0100))
                    {
                        Debug = "FCAP - Extended CAP offset is less than 0x100"
                        Return (Zero)
                    }
                }
                Else
                {
                    Local1 &= 0xFFFF
                    CAPP = (Local1 >> 0x08)
                    If ((CAPP < 0x40))
                    {
                        Debug = "FCAP - CAP offset is less than 0x40"
                        Return (Zero)
                    }
                }

                If (((CAPP & 0x03) != Zero))
                {
                    Debug = "FCAP - CAP is not on DWORD boundary"
                    Return (Zero)
                }
            }

            Debug = "FCAP - CAP Not Found"
            Return (Zero)
        }

        Method (HDPC, 1, NotSerialized)
        {
            Local0 = FCAP (Arg0, 0x00, 0x10)
            Local1 = FCAP (Arg0, 0x01, 0x1D)
            If (((Local0 != Zero) && (Local1 != Zero)))
            {
                If ((RD08 (Arg0, (Local0 + 0x14)) & 0x40))
                {
                    Debug = Concatenate (Concatenate ("HDPC - BDF ", ToHexString (Arg0)), " is DPC and Hotplug capable")
                    Return (Local1)
                }
                Else
                {
                    Return (0x00)
                }
            }

            Return (0x00)
        }

        Method (GPTP, 1, Serialized)
        {
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            Local1 = FCAP (Arg0, 0x00, 0x10)
            If ((Local1 != Zero))
            {
                OperationRegion (PCIS, SystemMemory, (Local0 + Local1), 0x10)
                Field (PCIS, DWordAcc, Lock, Preserve)
                {
                    Offset (0x02), 
                        ,   4, 
                    TYPE,   4
                }

                Debug = Concatenate (Concatenate (Concatenate ("GPTP Get Port Type - Arg0 ", ToHexString (Arg0)), " returns "), 
                    ToHexString (TYPE))
                Return (TYPE) /* \_SB_.GPTP.TYPE */
            }

            Return (0xFF)
        }

        Method (ENCE, 1, Serialized)
        {
            Debug = Concatenate ("ENCE Enable Correctable Error - Arg0 ", ToHexString (Arg0))
            Local0 = (0x80000000 + (Arg0 << 0x0C))
            Local1 = FCAP (Arg0, 0x00, 0x10)
            OperationRegion (PCIS, SystemMemory, (Local0 + Local1), 0x24)
            Field (PCIS, DWordAcc, Lock, Preserve)
            {
                Offset (0x02), 
                    ,   4, 
                TYPE,   4, 
                Offset (0x08), 
                DCOR,   1, 
                Offset (0x1C), 
                RCOR,   1
            }

            DCOR = 0x01
            If ((TYPE == 0x04))
            {
                RCOR = 0x01
            }
        }

        Method (SDPC, 2, Serialized)
        {
            Debug = Concatenate (Concatenate (Concatenate ("SDPC(Enable/Disable) DPC - BDF(Arg0) ", ToHexString (Arg0)), ", (Enable/Disable)Arg1 "), 
                ToHexString (Arg1))
            Local0 = FCAP (Arg0, 0x01, 0x1D)
            If ((Local0 == Zero))
            {
                Return (Zero)
            }

            Local1 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (DPCS, SystemMemory, (Local0 + Local1), 0x40)
            Field (DPCS, DWordAcc, Lock, Preserve)
            {
                EXHR,   32, 
                    ,   5, 
                RPEC,   1, 
                PTLC,   1, 
                SWTC,   1, 
                RPSZ,   4, 
                ACEC,   1, 
                Offset (0x06), 
                TGEN,   2, 
                    ,   1, 
                    ,   1, 
                CORE,   1, 
                PTLP,   1, 
                    ,   1, 
                ACOR,   1, 
                    ,   1, 
                Offset (0x08), 
                Offset (0x10), 
                MCFG,   3, 
                Offset (0x11), 
                MKIO,   3, 
                Offset (0x12), 
                MMEM,   3, 
                Offset (0x14), 
                SCFG,   3, 
                Offset (0x15), 
                SEIO,   3, 
                Offset (0x16), 
                SMEM,   3
            }

            If ((Arg1 == 0x01))
            {
                If (PTLC)
                {
                    PTLP = 0x01
                }

                CORE = 0x01
                ACOR = 0x00
                TGEN = 0x02
                If (RPEC)
                {
                    MCFG = 0x03
                    MKIO = 0x03
                    MMEM = 0x00
                    SCFG = 0x00
                    SEIO = 0x00
                    If ((RD08 (Arg0, 0x19) == RD08 (Arg0, 0x1A)))
                    {
                        SMEM = 0x01
                    }
                    Else
                    {
                        SMEM = 0x00
                    }
                }
            }
            ElseIf ((Arg1 == 0x00))
            {
                CORE = 0x00
                TGEN = 0x00
            }
        }

        Method (RDPC, 1, Serialized)
        {
            Debug = Concatenate ("RDPC Read DPC Trigger State - Arg0 ", ToHexString (Arg0))
            Local0 = FCAP (Arg0, 0x01, 0x1D)
            If ((Local0 == Zero))
            {
                Return (Zero)
            }

            Local1 = (0x80000000 + (Arg0 << 0x0C))
            OperationRegion (DPCS, SystemMemory, (Local0 + Local1), 0x10)
            Field (DPCS, DWordAcc, Lock, Preserve)
            {
                Offset (0x08), 
                TRGS,   1, 
                TRGR,   2, 
                    ,   2, 
                TRRE,   2
            }

            Local2 = RD16 (Arg0, (Local0 + 0x06))
            Debug = Concatenate ("RDPC DPC Control ", ToHexString (Local2))
            Local2 = RD16 (Arg0, (Local0 + 0x08))
            Debug = Concatenate ("RDPC DPC Status ", ToHexString (Local2))
            If (TRGS)
            {
                If (((TRGR == 0x03) && (TRRE == 0x01)))
                {
                    Debug = Concatenate (Concatenate ("RDPC Port ", ToHexString (Arg0)), " is in software DPC state")
                    Return (One)
                }
            }

            Return (Zero)
        }

        Method (EIOS, 2, Serialized)
        {
            Name (BUS, 0x00)
            Name (DEV, 0x00)
            Name (FNC, 0x00)
            BUS = Arg1
            BUS &= 0xFF00
            BUS >>= 0x08
            DEV = Arg1
            DEV &= 0xF8
            DEV >>= 0x03
            FNC = Arg1
            FNC &= 0x07
            Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (
                "EIOS Arg0 ", ToHexString (Arg0)), " (1 = enable IIO SMI on PCIe ERR_COR) Arg1 0x"), ToHexString (Arg1)), " (Root Port or Switch DSP BDF @ Bus 0x"), 
                ToHexString (BUS)), " Dev "), ToDecimalString (DEV)), " Fnc "), ToDecimalString (
                FNC)), ")")
            If ((Arg0 == 0x01))
            {
                Debug = Concatenate (Concatenate (Concatenate (Concatenate ("EIOS Store Arg1 ", ToHexString (Arg1)), " to RASD.ISMI RAS_ACPI_SMM_DATA.DPC_EnIioSmiGen @ IADR 0x"
                    ), ToHexString (IADR)), " (phys addr)")
                ISMI = Arg1
                Debug = "EIOS Write 0xD8 DPC_CFG_IIO_PCIE_ERRCOR_SWSMI to SMIC IO Port B2h"
                SMIS = 0x00
                SMIC = 0xD8
                Debug = "EIOS Back from SMI"
                Debug = "EIOS Clearing RASD.ISMI RAS_ACPI_SMM_DATA.DPC_EnIioSmiGen"
                ISMI = Zero
            }
        }

        Method (SOSF, 2, Serialized)
        {
            Debug = Concatenate (Concatenate (Concatenate ("SOSF ", ToHexString (Arg0)), " Arg1 "), 
                ToHexString (Arg1))
            Name (LBUF, Buffer (0x0320)
            {
                 0x00                                             // .
            })
            LBUF = DPCB /* \DPCB */
            CreateByteField (Arg0, 0x00, DEVF)
            CreateByteField (Arg0, 0x01, BUSS)
            Debug = Concatenate (Concatenate (Concatenate ("BUSS ", ToHexString (BUSS)), " DEVF "), 
                ToHexString (DEVF))
            Local0 = 0x00
            While ((Local0 < 0x0190))
            {
                Local1 = (Local0 * 0x02)
                Local2 = (Local1 + 0x01)
                If (((DerefOf (LBUF [Local1]) == DEVF) && (DerefOf (
                    LBUF [Local2]) == BUSS)))
                {
                    Debug = Concatenate (Concatenate (Concatenate ("Found BDF ", ToHexString (Arg0)), " at offset "), 
                        ToHexString (Local0))
                    If ((Arg1 == 0x00))
                    {
                        Debug = Concatenate (Concatenate (Concatenate ("Clear OS Flag BDF ", ToHexString (Arg0)), " at offset "), 
                            ToHexString (Local0))
                        LBUF [Local1] = 0x00
                        LBUF [Local2] = 0x00
                    }

                    Break
                }

                If ((Arg1 == 0x01))
                {
                    If (((DerefOf (LBUF [Local1]) == Zero) && (DerefOf (
                        LBUF [Local2]) == Zero)))
                    {
                        LBUF [Local1] = DEVF /* \_SB_.SOSF.DEVF */
                        LBUF [Local2] = BUSS /* \_SB_.SOSF.BUSS */
                        Debug = Concatenate (Concatenate (Concatenate ("Store ", ToHexString (Arg0)), " at offset "), 
                            ToHexString (Local0))
                        DPCB = LBUF /* \_SB_.SOSF.LBUF */
                        Break
                    }
                }

                Local0++
            }

            Local0 = 0x00
            While ((Local0 < 0x0190))
            {
                Local1 = (Local0 * 0x02)
                Local2 = (Local1 + 0x01)
                Local3 = DerefOf (LBUF [Local1])
                Local4 = DerefOf (LBUF [Local2])
                If (((Local3 != Zero) || (Local4 != Zero)))
                {
                    Debug = Concatenate (Concatenate (Concatenate (Concatenate ("DPCB Entry ", ToHexString (Local0)), ":  "
                        ), ToHexString (Local4)), ToHexString (Local3))
                }
                Else
                {
                    Break
                }

                Local0++
            }
        }

        Method (DSMC, 5, Serialized)
        {
            Name (PRIB, 0x00)
            Name (SECB, 0x00)
            Name (SUBB, 0x00)
            Name (RBDF, 0x00)
            PRIB = Arg0
            SECB = Arg1
            SUBB = Arg2
            RBDF = Arg3
            Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate ("DSMC PRIB ", 
                ToHexString (PRIB)), ", SECB "), ToHexString (SECB)), " SUBB "), ToHexString (
                SUBB)), " RBDF "), ToHexString (RBDF)), " Arg4 "), ToHexString (Arg4
                ))
            If ((HDPC (RBDF) || GDPE (RBDF)))
            {
                SOSF (RBDF, Arg4)
            }

            If ((SECB != SUBB))
            {
                Name (DBDF, 0x00)
                Name (BUS, 0x00)
                Name (DEV, 0x00)
                Name (FUNC, 0x00)
                BUS = (SECB + 0x01)
                While ((BUS < SUBB))
                {
                    DEV = 0x00
                    While ((DEV < 0x20))
                    {
                        FUNC = 0x00
                        While ((FUNC < 0x08))
                        {
                            DBDF = (BUS << 0x08)
                            DBDF += (DEV << 0x03)
                            DBDF += FUNC /* \_SB_.DSMC.FUNC */
                            If ((RD32 (DBDF, 0x00) != 0xFFFFFFFF))
                            {
                                Debug = DBDF /* \_SB_.DSMC.DBDF */
                                If (HDPC (DBDF))
                                {
                                    SOSF (DBDF, Arg4)
                                }
                            }
                            ElseIf ((FUNC == Zero))
                            {
                                FUNC = 0x07
                            }

                            If (((FUNC == Zero) && ((RD08 (DBDF, 0x0E) & 0x80) == 
                                Zero)))
                            {
                                FUNC = 0x07
                            }

                            FUNC += 0x01
                        }

                        DEV += 0x01
                    }

                    BUS += 0x01
                }
            }
        }

        Method (OSTS, 3, Serialized)
        {
            Name (RBDF, 0x00)
            Name (TBDF, 0x00)
            Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate ("OSTS Arg0 ", ToHexString (Arg0)), 
                ", Arg1 "), ToHexString (Arg1)), ", Arg2 "), ToHexString (Arg2))
            Name (LBUF, Buffer (0xE0)
            {
                 0x00                                             // .
            })
            LBUF = DPCT /* \DPCT */
            Local0 = 0x00
            While ((Local0 < 0x20))
            {
                Local1 = (Local0 * 0x07)
                If ((DerefOf (LBUF [Local1]) != Zero))
                {
                    Local2 = (Local1 + 0x01)
                    Local3 = (Local1 + 0x02)
                    Local4 = (Local1 + 0x03)
                    Local5 = (Local1 + 0x04)
                    Local6 = (Local1 + 0x05)
                    Local7 = (Local1 + 0x06)
                    RBDF = (DerefOf (LBUF [Local3]) << 0x08)
                    RBDF |= DerefOf (LBUF [Local2])
                    TBDF = (DerefOf (LBUF [Local5]) << 0x08)
                    TBDF |= DerefOf (LBUF [Local4])
                    If (((Arg0 == RBDF) && (Arg1 == TBDF)))
                    {
                        LBUF [Local6] = Arg2
                        Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate (Concatenate ("Write _OST status ", ToHexString (Arg2
                            )), " to BDF "), ToHexString (TBDF)), " at offset "), ToHexString (Local0)
                            ), ".  EDR Status = "), ToHexString (DerefOf (LBUF [Local7])))
                        DPCT = LBUF /* \_SB_.OSTS.LBUF */
                        Break
                    }
                }

                Local0++
            }
        }

        Method (GDPE, 1, Serialized)
        {
            Name (LBUF, Buffer (0xC8)
            {
                 0x00                                             // .
            })
            Debug = Concatenate (Concatenate ("ASL OADR 0x", ToHexString (OADR)), " = DPCB buffer address (physical mem addr of ACPI rsvd mem DPC_OSFlag)")
            Debug = Concatenate (Concatenate ("ASL TADR 0x", ToHexString (TADR)), " = DPCT buffer address (physical mem addr of ACPI rsvd mem DPC_Triggered)")
            Debug = Concatenate (Concatenate ("ASL EADR 0x", ToHexString (EADR)), " = DPCE buffer address (physical mem addr of ACPI rsvd mem DPC_EnBDF)")
            LBUF = DPCE /* \DPCE */
            Debug = LBUF /* \_SB_.GDPE.LBUF */
            Name (RVAL, 0x00)
            CreateByteField (Arg0, 0x00, DEVF)
            CreateByteField (Arg0, 0x01, BUSS)
            Debug = Concatenate (Concatenate (Concatenate (Concatenate (Concatenate ("GDPE ", ToHexString (Arg0)), 
                " BUSS "), ToHexString (BUSS)), " DEVF "), ToHexString (DEVF))
            Local0 = 0x00
            While ((Local0 < 0x64))
            {
                Local1 = (Local0 * 0x02)
                Local2 = (Local1 + 0x01)
                If (((DerefOf (LBUF [Local1]) == DEVF) && (DerefOf (
                    LBUF [Local2]) == BUSS)))
                {
                    Debug = Concatenate (Concatenate (Concatenate ("GDPE Found BDF ", ToHexString (Arg0)), " at offset "), 
                        ToHexString (Local0))
                    If (FCAP (Arg0, 0x01, 0x1D))
                    {
                        RVAL = One
                    }

                    Break
                }
                ElseIf (((DerefOf (LBUF [Local1]) == Zero) && (DerefOf (
                    LBUF [Local2]) == Zero)))
                {
                    Break
                }

                Local0++
            }

            Return (RVAL) /* \_SB_.GDPE.RVAL */
        }
    }
}

